"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpFunctionApiController = void 0;
const api_1 = require("@mcma/api");
const uuid_1 = require("uuid");
function asStringMap(obj) {
    return Object.keys(obj).reduce((obj, key) => { var _a; obj[key] = (_a = obj[key]) === null || _a === void 0 ? void 0 : _a.toString(); return obj; }, {});
}
class HttpFunctionApiController {
    constructor(routes) {
        this.mcmaApiController = new api_1.McmaApiController(routes);
    }
    async handleRequest(request, response) {
        const requestContext = new api_1.McmaApiRequestContext(new api_1.McmaApiRequest({
            id: uuid_1.v4(),
            path: request.path,
            httpMethod: request.method,
            headers: asStringMap(request.headers),
            pathVariables: {},
            queryStringParameters: asStringMap(request.query),
            body: request.body
        }), process.env);
        await this.mcmaApiController.handleRequest(requestContext);
        response.statusCode = requestContext.response.statusCode;
        response.statusMessage = requestContext.response.statusMessage;
        for (const header in requestContext.response.headers) {
            response.setHeader(header, requestContext.response.headers[header]);
        }
        response.json(requestContext.response.body);
    }
}
exports.HttpFunctionApiController = HttpFunctionApiController;
